from __future__ import with_statement
from es import tell, isbot, getUseridList, AddonInfo, ServerVar, msg, usermsg
from gamethread import queue, delayedname, cancelDelayed
from playerlib import getPlayer
from configobj import ConfigObj
from os.path import join
from mutelib import getPlayer as getMPlayer
from services import use, isRegistered

info = AddonInfo()
info['name'] = 'Mute Sage'
info['basename'] = 'mutesage'
info['version'] = '0.0.3'
info['author'] = 'MiB'
info['url'] = 'http://addons.eventscripts.com/addons/view/mutesagepython'
info['description'] = 'Dead can\'t use voice chat.'

def immune(userid):
    if auth:
        return auth.isUseridAuthorized(userid, 'msim')
    return False

def mutevar(x):
    global roundmute
    roundmute = x

def mute(userid, msg=True):
    player = getMPlayer(userid)
    if voicechat:
        player.muteVoice()
    if textchat:
        player.muteText()
    if msg:
        if voicechat and not textchat:
            tell(userid, '#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultYour voicechat has been muted.')
        elif not voicechat and textchat:
            tell(userid, '#multi','#lightgreen|#greenMute Sage#lightgreen| #defaultYour text has been muted.')
        else:
            tell(userid, '#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultYour have been completely muted.')

def unmute(userid, msg=True):
    player = getMPlayer(userid)
    if voicechat:
        player.unmuteVoice()
    if textchat:
        player.unmuteText()
    if msg:
        if voicechat and not textchat:
            tell(userid, '#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultYour voicechat has been unmuted.')
        elif not voicechat and textchat:
            tell(userid, '#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultYour text has been unmuted.')
        else:
            tell(userid, '#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultYour have been completely unmuted.')  

def panel(userid, text):
    usermsg('create', 'panel', 'KeyHintText')
    usermsg('write', 'byte', 'panel', 1)
    usermsg('write', 'string', 'panel', text)
    usermsg('send', 'panel', userid)
    usermsg('delete', 'panel')

def rt(ax):
    if roundmute:
        if ax:
            mutevar(True)
            for userid in getUseridList():
                player = getPlayer(userid)
                if player.team != 2 or player.isdead or player.steamid in immunelist or immune(userid):
                    continue
                panel(userid, '________________\n\nRound Start Mute: ' + str(ax) + '\n________________')
                mute(userid, False)
            delayedname(1, 'roundtime', rt, (ax - 1))
        else:
            mutevar(False)
            for userid in getUseridList():
                player = getPlayer(userid)
                if player.team != 2 or player.isdead or player.steamid in immunelist or immune(userid):
                    continue
                panel(userid, '')
                unmute(userid)

def load():
    ServerVar('mute_sage_version', info['version'], 'Mute Sage\'s public variable version.').makepublic()

def unload():
    cancelDelayed('roundtime')

def round_start(ev):
    if roundtime:
        queue(msg('#multi', '#lightgreen|#greenMute Sage#lightgreen| #defaultTerrorists are muted for ' + str(roundtime) + ' seconds after round start.'))
        cancelDelayed('roundtime')
        rt(roundtime)

def es_map_start(ev):
    mutevar(False)

def round_end(ev):
    mutevar(True)

def player_spawn(ev):
    u = ev['userid']
    t = int(ev['es_userteam'])
    if isbot(u) or ev['es_steamid'] in immunelist or immune(u):
        return
    if t > 1:
        if roundmute and t == 2:
            mute(u)
        else:
            unmute(u)
    else:
        mute(u)

def player_death(ev):
    u = ev['userid']
    if isbot(u) or ev['es_steamid'] in immunelist or immune(u):
        return
    mute(u)

path = str(ServerVar('eventscripts_gamedir'))
config = ConfigObj(join(path, 'cfg/eventscripts/mutesage/config.ini'))
roundtime = int(config['roundtime'])
voicechat = int(config['mutevc'])
textchat = int(config['mutetc'])

roundmute = False

immunelist = set()

with open(join(path, 'cfg/eventscripts/mutesage/immunelist.txt'), 'rb') as file_object:
     for line in file_object.readlines():
         if line.startswith('//'):
             continue
         immunelist.add(line)

auth = False
if isRegistered('auth'):
    auth = use('auth')
    auth.registerCapability('msim', auth.ADMIN)
